/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and
University of Maryland at College Park.

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <iostream>

extern "C"{
#include "lide_c_param_spec.h"
}
#include "rndclab_h_rndc_subinit.h"
#include "rndclab_h_rndc_body.h"
extern "C"{
#include "lide_c_fifo_basic.h"
}
extern "C"{
#include "lide_c_basic.h"
}

#define PARAM_INDEX 0

int main(int argc, char **argv) {
    char *in_file = NULL;
    char *out_file = NULL;
    FILE *num_file;
    int detectedResult=0;

    int i = 0;
    int arg_count = 4;
    int img_num;

    /* Check program usage. */
    if (argc != arg_count) {
        fprintf(stderr, "lide_c_neuro_driver.exe error: arg count\n");
        exit(1);
    }

    /* Open the input and output file(s). */
    i = 1;
    in_file = argv[i++];
    out_file = argv[i++];
    num_file = fopen(argv[i++], "r");

    if (fscanf(num_file, "%d\t", &img_num)!=1){
        cerr<<"Failed to read number from input file"<<endl;
    }
    std::cout<<"in and out file: " << in_file << out_file << img_num << std::endl;
    auto body = new rndclab_h_rndc_body(in_file,out_file,img_num);
    auto subinit = new rndclab_h_rndc_subinit(detectedResult,
                                              (welt_cpp_actor*)body,
                                              PARAM_INDEX);

    for (i=0;i<img_num;i++){
        subinit->invoke();
        body->invoke();
    }

    rndclab_h_rndc_subinit_terminate(subinit);
    rndclab_h_rndc_body_terminate(body);

    return 0;
}
