/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include "Classifier_Support.h"

double hinge(double score)
{
        double returnval=0;
        if((1-score)>0)
        {
                returnval= (1-score)/2;
        }
        return returnval;
}


uint32_t max(double* array, uint32_t length)
{
	double max = array[0];
	uint32_t max_index = 0;
	uint32_t count = 0;
	
	for(count=1;count<length;count++)
	{
		if(array[count] > max )
		{
			max = array[count];
			max_index = count;
		}
	}
	return max_index;
}


void vector_subtract_inplace(double *a, double *b, uint32_t length)
{
	uint32_t count = 0;
	for(count=0;count<length;count++)
	{
		a[count] -= b[count];
	}
	return;
}


void vector_scale_inplace(double *a, double *b, uint32_t length)
{
	uint32_t count = 0;
	for(count=0;count<length;count++)
	{
		a[count] /= b[count];
	}
	return;
}


void vector_dotproduct(double *a, double *b, double *c, uint32_t length)
{
	uint32_t count = 0;
	
	for(count=0;count<length;count++)
	{	
		*c += a[count]*b[count]; 
	}
	return;
}
