/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include "rndclab_h_rndc_body.h"

#define SUBGRAPH_COUNT_BODY 1
#define BODY_SUBGRAPH 0
#define PARAM_COUNT_BODY 1

using namespace std;

rndclab_h_rndc_body::rndclab_h_rndc_body(char *in_file,
        char *out_file, int img_num) {
    this->subgraph_count = SUBGRAPH_COUNT_BODY;
    this->mode = RNDCLAB_H_RNDC_BODY_MODE;

    /* Initialize parameters, the first four parameters is set by set_param
     * actor (read by neuron detection actor), and the last one param[4] is the
     * number of detected neurons set by neuron detection actor (read by
     * set_param actor */
    this->params_arr = new int[5];
    for(int idx = 0; idx < 5; idx++) {
        this->params_arr[idx]=999;
        this->params_vec.push_back(&params_arr[idx]);
    }
    this->subgraphs.push_back(new rndclab_body_subgraph(in_file,
            out_file, img_num, this->params_arr));

    /* old way initialize parameters */
//    this->param_length = (int *) lide_c_util_malloc(sizeof(int));
//    this->param_length[0] = 4;
//    this->param = (int *) lide_c_util_malloc(sizeof(int) * (4));
//    this->max_param_count = PARAM_COUNT_BODY;
//    welt_cpp_actor_init_vari_paramrefs(this, this->param_length,
//            PARAM_COUNT_BODY, this->param);
}

rndclab_h_rndc_body::~rndclab_h_rndc_body() {
    cout << "delete h_body actor" << endl;
}

int rndclab_h_rndc_body::enable() {
    boolean result = FALSE;
    switch (mode) {
        case RNDCLAB_H_RNDC_BODY_MODE:result = TRUE;
            break;
        default:result = FALSE;
            break;
    }
    return result;
}

void rndclab_h_rndc_body::invoke() {
    switch (mode) {
        case RNDCLAB_H_RNDC_BODY_MODE: {
            subgraphs[BODY_SUBGRAPH]->scheduler();
            mode = RNDCLAB_H_RNDC_BODY_MODE;
            break;
        }
        default:mode = RNDCLAB_H_RNDC_BODY_MODE;
            break;
    }
}

void rndclab_h_rndc_body::reset() {
    mode = RNDCLAB_H_RNDC_BODY_MODE;
}

void rndclab_h_rndc_body::connect(welt_cpp_graph *graph) {

}

void rndclab_h_rndc_body_terminate(rndclab_h_rndc_body *context) {
    rndclab_body_subgraph_terminate(
            (rndclab_body_subgraph *) context
                    ->subgraphs[BODY_SUBGRAPH]);
    delete context;
}
