#ifndef _rndclab_h_rndc_body_h
#define _rndclab_h_rndc_body_h

/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

extern "C" {
#include "lide_c_util.h"
#include "lide_c_actor.h"
#include "lide_c_fifo.h"
//#include "lide_c_fifo_basic.h"
#include "welt_c_fifo.h"
}

#include "welt_cpp_actor.h"
#include "welt_cpp_graph.h"
#include "welt_cpp_actor.h"

#include "rndclab_body_subgraph.h"

/* Actor modes */
#define RNDCLAB_H_RNDC_BODY_MODE       0

/*******************************************************************************
 TYPE DEFINITIONS
 *******************************************************************************/
/* Structure and pointer types associated with h_rndc_body objects. */

class rndclab_h_rndc_body : public welt_cpp_actor{
public:
    rndclab_h_rndc_body(char *in_file,
                                char *out_file, int img_num);

    virtual ~rndclab_h_rndc_body();

    int enable() override;

    void invoke() override;

    void reset() override;

    void connect(welt_cpp_graph *graph) override;

private:
    /* old way initialize parameters */
//    int *param;
    int img_num;

    int *params_arr;
};

/*******************************************************************************
 INTERFACE FUNCTIONS
 *******************************************************************************/

/*****************************************************************************
 Terminate function of the lide_c_h_rndc_body actor.
 *****************************************************************************/
void rndclab_h_rndc_body_terminate(rndclab_h_rndc_body *context);

#endif
