/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include "rndclab_h_rndc_subinit.h"

#define SUBGRAPH_COUNT_SUBINIT 1
#define SUBINIT_SUBGRAPH 0

rndclab_h_rndc_subinit::rndclab_h_rndc_subinit(int
detectedResult, welt_cpp_actor *body_actor, int param_index) {
    this->subgraph_count = SUBGRAPH_COUNT_SUBINIT;
    this->subgraphs.push_back(new rndclab_subinit_subgraph
    (body_actor, detectedResult, param_index));
    this->detectedResult = detectedResult;
    this->mode = LIDE_C_H_RNDC_SUBINIT_MODE;
}

int rndclab_h_rndc_subinit::enable() {
    boolean result = FALSE;
    switch (mode) {
        case LIDE_C_H_RNDC_SUBINIT_MODE:result = TRUE;
            break;
        default:result = FALSE;
            break;
    }
    return result;
}

void rndclab_h_rndc_subinit::invoke() {
    switch (mode) {
        case LIDE_C_H_RNDC_SUBINIT_MODE:
            subgraphs[SUBINIT_SUBGRAPH]->scheduler();
            mode = LIDE_C_H_RNDC_SUBINIT_MODE;
            break;
        default:mode = LIDE_C_H_RNDC_SUBINIT_MODE;
            break;
    }
}

void rndclab_h_rndc_subinit::reset() {
    mode = LIDE_C_H_RNDC_SUBINIT_MODE;
}

void rndclab_h_rndc_subinit::connect(welt_cpp_graph *graph) {

}

void rndclab_h_rndc_subinit_terminate(
        rndclab_h_rndc_subinit *context) {
    rndclab_subinit_subgraph_terminate(
            (rndclab_subinit_subgraph *) context
                    ->subgraphs[SUBINIT_SUBGRAPH]);
    delete context;
}
