/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>
#include <sstream>
#include <string>

#include "rndclab_img_read.h"

#define MAX_FIFO_COUNT  1
using namespace cv;
using namespace std;

rndclab_img_read::rndclab_img_read(char *first_file,
                                                   int img_num,
                                                   lide_c_fifo_pointer img_out) {
    this->out = (welt_c_fifo_pointer)img_out;
    this->subgraph_count = 0;
    this->max_port_count = MAX_FIFO_COUNT;
    this->mode = RNDCLAB_IMG_READ_MODE_SRC_UPDATE;
    this->first_file = first_file;

    this->img_num = img_num;
    this->img_index = 1;
    this->first_file = first_file;
    strcpy(this->file_name_val, this->first_file);
    this->temp = &this->file_name_val[0];
    //this->index = index;
    this->out = (welt_c_fifo_pointer) img_out;
}

rndclab_img_read::~rndclab_img_read() {
    cout << "delete img read actor" << endl;
}

int rndclab_img_read::enable() {
    boolean result = FALSE;
    switch (mode) {
        case RNDCLAB_IMG_READ_MODE_SRC_UPDATE:

            result = (welt_c_fifo_population(out) <
                      welt_c_fifo_capacity(out));
            break;
        case RNDCLAB_IMG_READ_MODE_INACTIVE:
            result = FALSE;
            break;
        default:
            result = FALSE;
            break;
    }
    return result;
}

void rndclab_img_read::invoke() {
    string present_file_name = temp;
    string next_file_name;
    string out_file;
    switch (mode) {
        case RNDCLAB_IMG_READ_MODE_SRC_UPDATE:

            if (img_index == img_num + 1) {
                mode = RNDCLAB_IMG_READ_MODE_INACTIVE;
                break;
            }

            {
                printf("read img addr: %s\n", temp);
                /*load current image*/
                std::string readname(temp);
                Mat img_read = imread(readname);

//                in = img_read.clone();
                img_read.copyTo(img_in);
                Mat* img_send = &img_in;

                /*write the image pointer to the output fifo*/
                welt_c_fifo_write(out, &img_send);

                /* The file name for input should be XX_1.XX ()*/
                /*string operation to update current image name*/
//                char *fileTestName = temp;
                char next[strlen(temp) + 1];
                strcpy(next, temp);

                char *tpe = strrchr(next, '.');
                char c = *tpe;
                *tpe = '\0';
                char *numS = strrchr(next, '_');
                numS += sizeof(char);
                int number = atoi(numS);
                *tpe = c;
                *numS = '\0';
                number++;

                int numberOut = number;
                int cnt = 1;
                while (number / 10 != 0) {
                    number /= 10;
                    cnt++;
                }

                char numCvt[cnt + 1];
                sprintf(numCvt, "%d", numberOut);

                char *str3 = (char *) (malloc(
                        1 + strlen(next) + strlen(numCvt) + strlen(tpe)));
                strcpy(str3, next);
                strcat(str3, numCvt);
                strcat(str3, tpe);
                strcpy(temp, str3);

            }

            mode = RNDCLAB_IMG_READ_MODE_SRC_UPDATE;
            break;

        case RNDCLAB_IMG_READ_MODE_INACTIVE:
            mode = RNDCLAB_IMG_READ_MODE_INACTIVE;
            break;

        default:mode = RNDCLAB_IMG_READ_MODE_INACTIVE;
            break;
    }
}

void rndclab_img_read::reset() {
    mode = RNDCLAB_IMG_READ_MODE_SRC_UPDATE;
}

void rndclab_img_read::connect(welt_cpp_graph *graph) {
//    int port_index;
//    int direction;
//    direction = GRAPH_OUT_CONN_DIRECTION;
//    port_index = 0;
//    lide_c_graph_add_connection(graph, (lide_c_actor_type *) context,
//                                port_index, direction);
}

void rndclab_img_read_terminate(rndclab_img_read *context) {
    delete context;
}


