/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>
#include <sstream>
#include <stdlib.h>
#include "opencv2/imgproc/imgproc.hpp"
#include "opencv2/imgcodecs/imgcodecs.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/videoio/videoio.hpp"
#include "opencv2/video/video.hpp"
#include "rndclab_img_write.h"
#define MAX_FIFO_COUNT  1

using namespace cv;
using namespace std;

rndclab_img_write::rndclab_img_write(
        lide_c_fifo_pointer img_in, char *filename, int img_num) {
    this->mode = LIDE_C_IMG_WRITE_MODE_SNK_UPDATE;
    this->img_num = img_num;
    this->img_index = 1;
    this->filename = filename;
    this->temp = filename;
    this->img_in = (welt_c_fifo_pointer) img_in;
    //this->index = index;
    this->subgraph_count = 0;
    this->max_port_count = MAX_FIFO_COUNT;
}

int rndclab_img_write::enable() {
    boolean result = FALSE;
    switch (mode) {
        case LIDE_C_IMG_WRITE_MODE_SNK_UPDATE:
            result = welt_c_fifo_population(img_in) >= 1;
            break;
        default:result = FALSE;
            break;
    }
    return result;
}

void rndclab_img_write::invoke() {
    string present_file_name = temp;
    string next_file_name;
    switch (mode) {
        case LIDE_C_IMG_WRITE_MODE_SNK_UPDATE: {
            Mat *Iout;
            welt_c_fifo_read(img_in, &Iout);
            imwrite(temp, *Iout);
            string fn(present_file_name);
            int index = fn.find_last_of("/");
            int index3 = fn.find_last_of(".");
            int index2 = fn.find_last_of("_");
            if (index2 == -1) {
                index2 = index3;
            }
            string in_prefix = fn.substr(0, index + 1);
            string in_suffix = fn.substr(index2);
            string in_string = fn.substr(index + 1, index2 - index - 1);
            istringstream iss(in_string);
            int in_number = 1;
            iss >> in_number;
            ostringstream oss;
            oss << (in_number + 1);
            string next_string = oss.str();
            next_file_name = in_prefix + next_string + in_suffix;
            strcpy(temp, next_file_name.c_str());
            present_file_name = next_file_name;
            img_index++;
            mode = LIDE_C_IMG_WRITE_MODE_SNK_UPDATE;
            break;
        }
        default:
            mode = LIDE_C_IMG_WRITE_MODE_SNK_UPDATE;
            break;
    }
}

void rndclab_img_write::reset() {
    mode = LIDE_C_IMG_WRITE_MODE_SNK_UPDATE;
}

void rndclab_img_write::connect(welt_cpp_graph *graph) {
//    int port_index;
//    int direction;
//    /* input 1*/
//    direction = GRAPH_IN_CONN_DIRECTION;
//    port_index = 0;
//    lide_c_graph_add_connection(graph, (lide_c_actor_type *) context,
//                                port_index, direction);
}

void rndclab_img_write_terminate(rndclab_img_write *context) {
    delete context;
}

