#ifndef _rndclab_signal_extraction_h
#define _rndclab_signal_extraction_h

/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

extern "C" {
#include "lide_c_util.h"
#include "lide_c_actor.h"
#include "lide_c_fifo.h"
#include "welt_c_fifo.h"
}

#include "welt_cpp_actor.h"
#include "welt_cpp_graph.h"
#include "welt_cpp_actor.h"

#define LIDE_C_SIGNAL_EXTRACTION_MODE_INACTIVE       1
#define LIDE_C_SIGNAL_EXTRACTION_MODE_PROCESS    2
#define LIDE_C_SIGNAL_EXTRACTION_MODE_TRANSITION_DECISION 3

class rndclab_signal_extraction : public welt_cpp_actor{
public:
    rndclab_signal_extraction(
            lide_c_fifo_pointer img_in, lide_c_fifo_pointer sig_in,
            lide_c_fifo_pointer signal_out);

    virtual ~rndclab_signal_extraction();

    int enable() override;

    void invoke() override;

    void reset() override;

    void connect(welt_cpp_graph *graph) override;

private:
    /*Actor interface ports.*/
    welt_c_fifo_pointer img_in;
    welt_c_fifo_pointer sig_in;
    /* Signal block output to prediction actor */
    welt_c_fifo_pointer signal_out;
    int img_num;
};

void rndclab_signal_extraction_terminate(
        rndclab_signal_extraction *context);

#endif

