/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "rndclab_subinit_subgraph.h"

#define NAME_LENGTH 20
#define ACTOR_COUNT_SUBINIT 1

rndclab_subinit_subgraph::rndclab_subinit_subgraph
(welt_cpp_actor *body_actor, int detectedResult, int param_index) {
    int token_size;
    token_size = sizeof(int);

    this->actor_count = ACTOR_COUNT_SUBINIT;
    this->fifo_count = FIFO_COUNT_SUBINIT;
    for (int i = 0; i<this->fifo_count; i++){
        fifos.push_back((lide_c_fifo_pointer)welt_c_fifo_new
                (BUFFER_CAPACITY,token_size,i));
    }
//    strcpy(this->descriptors[ACTOR_SET_PARAM], "set parameter");

    /* Create and connect the actors. */
    actors.push_back(new rndclab_set_param(body_actor, detectedResult,
            param_index));
    descriptors.push_back("actor set param");
    actors[ACTOR_SET_PARAM]->connect((welt_cpp_graph*) this);
}

void rndclab_subinit_subgraph::scheduler() {
    actors[ACTOR_SET_PARAM]->invoke();

}

void rndclab_subinit_subgraph_terminate(
        rndclab_subinit_subgraph *context) {
//    int i;
//    /* Terminate FIFO*/
//    for (i = 0; i < context->fifo_count; i++) {
//        welt_c_fifo_free((welt_c_fifo_pointer) context->fifos[i]);
//    }

    /* Terminate Actors*/
    rndclab_set_param_terminate((rndclab_set_param *)
    context->actors[ACTOR_SET_PARAM]);
//    free(context->fifos);
//    free(context->actors);
//    free(context->descriptors);
    delete context;
    return;
}




