#ifndef _rndclab_init_subgraph_h
#define _rndclab_init_subgraph_h

/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 2017-2020
UMB-UMD Neuromodulation Research Group,
University of Maryland at Baltimore, and 
University of Maryland at College Park. 

All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BALTIMORE
OR UNIVERSITY OF MARYLAND COLLEGE PARK BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

extern "C" {
#include "lide_c_basic.h"
#include "lide_c_actor.h"
#include "lide_c_fifo.h"
#include "welt_c_fifo.h"
#include "lide_c_graph.h"
#include "lide_c_util.h"
}
#include "welt_cpp_graph.h"
#include "welt_cpp_util.h"

#include "rndclab_set_param.h"

#define BUFFER_CAPACITY 1024

/* An enumeration of the actors in this application. */
#define ACTOR_SET_PARAM   0

/* An enumeration of the fifos in this application. */
#define FIFO_SRC_OUT 0

#define FIFO_COUNT_SUBINIT      0

/*******************************************************************************
 TYPE DEFINITIONS
 *******************************************************************************/

class rndclab_subinit_subgraph : public welt_cpp_graph{
public:
    rndclab_subinit_subgraph(welt_cpp_actor *body_actor, int
    detectedResult, int param_index);

    void scheduler() override;

private:
    int *param;
    int detectedResult;
};

/*******************************************************************************
 INTERFACE FUNCTIONS
 *******************************************************************************/

void rndclab_subinit_subgraph_terminate(
        rndclab_subinit_subgraph *context);

#endif

