/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>

#include "welt_cpp_add.h"

#define MAX_FIFO_COUNT  1

using namespace std;

welt_cpp_add::welt_cpp_add
        (lide_c_fifo_pointer in1,
         lide_c_fifo_pointer in2,
         lide_c_fifo_pointer in3,
         lide_c_fifo_pointer out,
         int index) {
    this->mode = WELT_CPP_ADD_MODE_PROCESS;
    this->in1 = (lide_c_fifo_basic_pointer)in1;
    this->in2 = (lide_c_fifo_basic_pointer)in2;
    this->in3 = (lide_c_fifo_basic_pointer)in3;
    this->out = (lide_c_fifo_basic_pointer)out;
    this->index = index;
//    this->subgraphs = nullptr;
    this->subgraph_count = 0;
    this->max_port_count = MAX_FIFO_COUNT;
//    FIXME: port init_portrefs and add_portrefs functions to cpp
    /* Initialize portrefs*/
    /*
    lide_c_actor_init_portrefs((lide_c_actor_context_type *)context,
        FIFO_COUNT, &context->in1, &context->in2, &context->out);
    */
//    lide_c_actor_init_portrefs((lide_c_actor_context_type *)context);
//    lide_c_actor_add_portrefs((lide_c_actor_context_type *)context,
//                              (lide_c_fifo_pointer *)&context->in1);
//    lide_c_actor_add_portrefs((lide_c_actor_context_type *)context,
//                              (lide_c_fifo_pointer *)&context->in2);
//    lide_c_actor_add_portrefs((lide_c_actor_context_type *)context,
//                              (lide_c_fifo_pointer *)&context->out);
}

boolean welt_cpp_add::enable() {
    boolean result = FALSE;

    switch (mode) {
        case WELT_CPP_ADD_MODE_PROCESS:
            result = (lide_c_fifo_basic_population(in1) >= 1)
                     && (lide_c_fifo_basic_population(in2) >= 1)
                     && (lide_c_fifo_basic_population(in3) >= 1)
                     && (lide_c_fifo_basic_population(out) <
                          lide_c_fifo_basic_capacity(out));
            break;
        default:
            result = FALSE;
            break;
    }
    return result;
}

void welt_cpp_add::invoke() {
    switch (mode) {
        case WELT_CPP_ADD_MODE_PROCESS: {
            int value1 = 0;
            int value2 = 0;
            int value3 = 0;
            int sum = 0;
            lide_c_fifo_basic_read(in1, &value1);
            lide_c_fifo_basic_read(in2, &value2);
            lide_c_fifo_basic_read(in3, &value3);
            sum = value1 + value2 + value3;
//            cout << "add actor value: " << sum << endl;
            lide_c_fifo_basic_write(out, &sum);
            mode = WELT_CPP_ADD_MODE_PROCESS;
            break;
        }
        default:
            mode = WELT_CPP_ADD_MODE_PROCESS;
            break;
    }
}

void welt_cpp_add::reset() {
    mode = WELT_CPP_ADD_MODE_PROCESS;
}

//void welt_cpp_add::connect(welt_cpp_graph *graph, (welt_cpp_actor*)context) {
//    int port_index;
//    int direction;

//    FIXME: following lines are waiting for the util functions being ported
//    /* input 1*/
//    direction = GRAPH_IN_CONN_DIRECTION;
//    port_index = 0;
//    welt_cpp_graph_add_connection(graph, (welt_cpp_actor*)context,
//                                port_index, direction);
//
//    /* input 2*/
//    direction = GRAPH_IN_CONN_DIRECTION;
//    port_index = 1;
//    welt_cpp_graph_add_connection(graph, (welt_cpp_actor*)context,
 //                               port_index, direction);
//
//    /* output 1*/
 //   direction = GRAPH_OUT_CONN_DIRECTION;
 //   port_index = 2;
 //   welt_cpp_graph_add_connection(graph, (welt_cpp_actor*)context,
  //                              port_index, direction);
//}

welt_cpp_add::~welt_cpp_add() {
    cout << "delete add actor" << endl;
}

void welt_cpp_add_terminate(welt_cpp_add *context) {
    delete context;
}
