/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>

#include "welt_cpp_imread.h"

#define MAX_FIFO_COUNT 1

using namespace cv;
using namespace std;

// constructor
welt_cpp_imread::welt_cpp_imread(lide_c_fifo_pointer out,
                                                 int index) {
    this->out = (lide_c_fifo_basic_pointer)out;
    this->index = index;
//    this->subgraphs = nullptr;
    this->subgraph_count = 0;
    this->max_port_count = MAX_FIFO_COUNT;
    this->mode = WELT_CPP_IMREAD_MODE_WRITE;
}

boolean welt_cpp_imread::enable() {
    boolean result = FALSE;

    switch (mode) {
        case WELT_CPP_IMREAD_MODE_WRITE:
            result = (lide_c_fifo_basic_population(out) <
                      lide_c_fifo_basic_capacity(out));
            break;
        case WELT_CPP_IMREAD_MODE_INACTIVE:
            result = FALSE;
            break;
        default:
            result = FALSE;
            break;
    }
    return result;
}

void welt_cpp_imread::invoke() {

    switch (mode) {
        case WELT_CPP_IMREAD_MODE_WRITE: {
            Mat img_read = imread(
                    "/Users/xiejing/Downloads/s01c05/input/frame_1.png");
            if (!img_read.data) {
                /* End of input */
                mode = WELT_CPP_IMREAD_MODE_INACTIVE;
                printf("There is no input image\n");
            } else {
                img_read.copyTo(img_in);
                Mat *img_send = &(img_in);
                lide_c_fifo_basic_write(out, &img_send);
                mode = WELT_CPP_IMREAD_MODE_WRITE;
            }
            break;
        }
        case WELT_CPP_IMREAD_MODE_INACTIVE:
            mode = WELT_CPP_IMREAD_MODE_INACTIVE;
            break;
        default:
            mode = WELT_CPP_IMREAD_MODE_INACTIVE;
            break;
    }
}

void welt_cpp_imread::reset() {
    mode = WELT_CPP_IMREAD_MODE_WRITE;
}

void welt_cpp_imread::connect(welt_cpp_graph *graph) {
    int port_index;
    int direction;

//    following lines are waiting for the util functions being ported
//    /* output 1*/
//    direction = GRAPH_OUT_CONN_DIRECTION;
//    port_index = 0;
//    lide_c_graph_add_connection(graph, (lide_c_actor_type *)context,
//                                port_index, direction);
}

welt_cpp_imread::~welt_cpp_imread() {
    cout << "delete imread actor" << endl;
}

void welt_cpp_imread_terminate(welt_cpp_imread *context) {
    delete context;
}
