/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/

#include <iostream>

#include "welt_cpp_simple_object_sink.h"

#include "token_object_example.h"

#define MAX_FIFO_COUNT  1

using namespace std;

welt_cpp_simple_object_sink::welt_cpp_simple_object_sink
        (lide_c_fifo_pointer in, char *file,
         int index) {
    this->file = file;
    this->fp = lide_c_util_fopen((const char *)this->file, "w");
    this->mode = WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ;
    this->in = (lide_c_fifo_basic_pointer)in;

    this->index = index;
    this->subgraph_count = 0;
    this->max_port_count = MAX_FIFO_COUNT;
//    FIXME: port init_portrefs and add_portrefs functions to cpp
    /* Initialize portrefs*/
    /*
    lide_c_actor_init_portrefs((lide_c_actor_context_type *)context,
        FIFO_COUNT, &context->in);
    */
//    lide_c_actor_init_portrefs((lide_c_actor_context_type *)context);
//    lide_c_actor_add_portrefs((lide_c_actor_context_type *)context,
//                              (lide_c_fifo_pointer *)&context->in);
}

boolean welt_cpp_simple_object_sink::enable() {
    boolean result = FALSE;

    switch (mode) {
        case WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ:
            result = lide_c_fifo_basic_population(in) >= 1;
            break;
        default:
            result = FALSE;
            break;
    }
    return result;
}

void welt_cpp_simple_object_sink::invoke() {
    switch (mode) {
        case WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ: {
            /* create a temporary object */
            token_object_example tokenObjectType(0, 0, 0, nullptr, nullptr);
            /* read the object from fifo */
            lide_c_fifo_basic_read(in, &tokenObjectType);
            /* display the object content */
            fprintf(fp, "Object info:{\n  name: %s\n", tokenObjectType.getName
            ());
            fprintf(fp, "  number1: %d\n", tokenObjectType.getNum1());
            fprintf(fp, "  number2: %f\n", tokenObjectType.getNum2());
            fprintf(fp, "  number3: %f\n", tokenObjectType.getNum3());
            fprintf(fp, "  description: %s\n}\n\n", tokenObjectType.getDesc()
            ->c_str());
            mode = WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ;
            break;
        }
        default:
            mode = WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ;
            break;
    }
}

void welt_cpp_simple_object_sink::reset() {
    mode = WELT_CPP_SIMPLE_OBJECT_SINK_MODE_READ;
}

void welt_cpp_simple_object_sink::connect(welt_cpp_graph *graph) {
    int port_index;
    int direction;

//    following lines are waiting for the util functions being ported
//    /* input 1*/
//    direction = GRAPH_IN_CONN_DIRECTION;
//    port_index = 0;
//    lide_c_graph_add_connection(graph, (lide_c_actor_context_type *)context,
//                                port_index, direction);
}

welt_cpp_simple_object_sink::~welt_cpp_simple_object_sink() {
    fclose(fp);
    cout << "delete file sink actor" << endl;
}

void welt_cpp_simple_object_sink_terminate(welt_cpp_simple_object_sink
*context) {
    delete context;
}
