/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/
#include <stdio.h>
#include <stdlib.h>

#include "lide_c_add_graph.h"

#include "lide_c_util.h"


/* 
    Usage: lide_c_add_driver.exe x_file y_file out_file
*/
int main(int argc, char **argv) {
    char *x_file = NULL; 
    char *y_file = NULL; 
    char *out_file = NULL; 
    
    int i = 0;
    int arg_count = 4;
    lide_c_graph_context_type *graph_context;
    lide_c_fifo_pointer new_fifo;
    
    
    /* Check program usage. */
    if (argc != arg_count) {
        fprintf(stderr, "lide_c_add_driver.exe error: arg count\n");
        exit(1);
    }   

    /* Open the input and output file(s). */
    i = 1;
    x_file = argv[i++]; 
    y_file = argv[i++]; 
    out_file = argv[i++]; 

    graph_context = (lide_c_graph_context_type *)
                    lide_c_add_graph_new(x_file, y_file, out_file);
    new_fifo = (lide_c_fifo_pointer)lide_c_fifo_basic_new
                            (128, sizeof(int), 3);
    
    /*change one fifo in the graph */
    
    lide_c_actor_set_portref(graph_context->actors[2],
        2, new_fifo);
    lide_c_actor_set_portref(graph_context->actors[3],
        0, new_fifo);
    /* Execute the graph. */
    lide_c_util_simple_scheduler(graph_context->actors, 
                    graph_context->actor_count, graph_context->descriptors);
    
    
    /* Normal termination. */
    lide_c_add_graph_terminate(
            (lide_c_add_graph_context_type *)graph_context);
    return 0;
}
