#ifndef _lide_c_cdsg_static_loop_h
#define _lide_c_cdsg_static_loop_h

/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/
#include "lide_c_actor.h"
#include "lide_c_basic.h"
#include "lide_c_fifo.h"
#include "lide_c_graph_def.h"
#include "lide_c_fifo_unit_size.h"

/* Actor modes */
#define LIDE_C_CDSG_STATIC_LOOP_MODE_ERROR      0 
#define LIDE_C_CDSG_STATIC_LOOP_MODE_PROCESS    1 
#define LIDE_C_CDSG_STATIC_LOOP_MODE_WAIT       2 
#define LIDE_C_CDSG_STATIC_LOOP_SUBMODE_PROCESS_A  3 
#define LIDE_C_CDSG_STATIC_LOOP_SUBMODE_PROCESS_B  4 



/*******************************************************************************
TYPE DEFINITIONS
*******************************************************************************/

/* Structure and pointer types associated with sca_static_loop_actor objects. */
struct _lide_c_cdsg_static_loop_context_struct;
typedef struct _lide_c_cdsg_static_loop_context_struct 
        lide_c_cdsg_static_loop_context_type;
        
/*******************************************************************************
INTERFACE FUNCTIONS
*******************************************************************************/

lide_c_cdsg_static_loop_context_type *lide_c_cdsg_static_loop_new(
        //lide_c_fifo_unit_size_pointer in1, 
        lide_c_fifo_pointer in1, 
        //lide_c_fifo_unit_size_pointer in2, 
        lide_c_fifo_pointer in2, 
        //lide_c_fifo_unit_size_pointer out1, 
        lide_c_fifo_pointer out1, 
        //lide_c_fifo_unit_size_pointer out2,
        lide_c_fifo_pointer out2,
        int iteration_count, int *current_iteration, int index);

boolean lide_c_cdsg_static_loop_enable( 
        lide_c_cdsg_static_loop_context_type *context); 

void lide_c_cdsg_static_loop_invoke(
        lide_c_cdsg_static_loop_context_type *context); 

void lide_c_cdsg_static_loop_terminate(
        lide_c_cdsg_static_loop_context_type *context);
        
/* Set and get for current_iteration and iteration_count function*/
void lide_c_cdsg_static_loop_set_current_iteration(
    lide_c_cdsg_static_loop_context_type *context, 
    int *current_iteration);

int lide_c_cdsg_static_loop_get_current_iteration(
    lide_c_cdsg_static_loop_context_type *context);

void lide_c_cdsg_static_loop_set_iteration_count(
    lide_c_cdsg_static_loop_context_type *context, 
    int iteration_count);

int lide_c_cdsg_static_loop_get_iteration_count(
    lide_c_cdsg_static_loop_context_type *context);
    
void lide_c_cdsg_static_loop_set_index(
lide_c_cdsg_static_loop_context_type *context, int index);

int lide_c_cdsg_static_loop_get_index(
lide_c_cdsg_static_loop_context_type *context);

void lide_c_cdsg_static_loop_connect(lide_c_actor_context_type *context, 
        struct lide_c_graph_context_struct *graph);

   
#endif
