#ifndef _lide_c_sca_fi_h
#define _lide_c_sca_fi_h

/*******************************************************************************
@ddblock_begin copyright

Copyright (c) 1997-2020
Maryland DSPCAD Research Group, The University of Maryland at College Park 
All rights reserved.

IN NO EVENT SHALL THE UNIVERSITY OF MARYLAND BE LIABLE TO ANY PARTY
FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
THE UNIVERSITY OF MARYLAND HAS BEEN ADVISED OF THE POSSIBILITY OF
SUCH DAMAGE.

THE UNIVERSITY OF MARYLAND SPECIFICALLY DISCLAIMS ANY WARRANTIES,
INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
MARYLAND HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
ENHANCEMENTS, OR MODIFICATIONS.

@ddblock_end copyright
*******************************************************************************/
#include "lide_c_actor.h"
#include "lide_c_basic.h"
#include "lide_c_fifo.h"
#include "lide_c_graph_def.h"
#include "lide_c_fifo_unit_size.h"

/* Actor modes */
#define LIDE_C_SCA_FI_MODE_ERROR      0 
#define LIDE_C_SCA_FI_MODE_PROCESS    1 


/*******************************************************************************
TYPE DEFINITIONS
*******************************************************************************/

/* Structure and pointer types associated with sca_fi_actor objects. */
struct _lide_c_sca_fi_context_struct;
typedef struct _lide_c_sca_fi_context_struct 
        lide_c_sca_fi_context_type;
        
/*******************************************************************************
INTERFACE FUNCTIONS
*******************************************************************************/

lide_c_sca_fi_context_type *lide_c_sca_fi_new(
        //lide_c_fifo_unit_size_pointer in1, 
        lide_c_fifo_pointer in1, 
        //lide_c_fifo_unit_size_pointer in2, 
        lide_c_fifo_pointer in2, 
        //lide_c_fifo_unit_size_pointer out1, 
        lide_c_fifo_pointer out1, 
        int input_port_count, int index);

boolean lide_c_sca_fi_enable( 
        lide_c_sca_fi_context_type *context); 

void lide_c_sca_fi_invoke(
        lide_c_sca_fi_context_type *context); 

void lide_c_sca_fi_terminate(
        lide_c_sca_fi_context_type *context);
        
/* Set and get for input_port_count function*/
/*
void lide_c_sca_fi_set_input_port_count(
    lide_c_sca_fi_context_type *context, 
    int input_port_count);

int lide_c_sca_fi_get_input_port_count(
    lide_c_sca_fi_context_type *context);
*/
    
/* Set and get function for pointer to input FIFO array*/
/*
void lide_c_sca_fi_set_in_pointer(
    lide_c_sca_fi_context_type *context, 
    lide_c_fifo_unit_size_pointer *in);

lide_c_fifo_unit_size_pointer *lide_c_sca_fi_get_in_pointer(
    lide_c_sca_fi_context_type *context);
*/
    
void lide_c_sca_fi_set_index(
lide_c_sca_fi_context_type *context, int index);

int lide_c_sca_fi_get_index(
lide_c_sca_fi_context_type *context);

void lide_c_sca_fi_connect(lide_c_actor_context_type *context, 
        struct lide_c_graph_context_struct *graph);  
    
#endif
